;;; -*-byte-compile-dynamic: t;-*-
;;; od-chujiten64.el --- dictionary-dependent file (new eiwa-waei chujiten)
;; Author: YAMAMOTO Mitsuharu <mituharu@is.s.u-tokyo.ac.jp>

(eval-and-compile

(defconst od-chujiten-capfunc-table
  '((0 . od-chujiten-insert-frames-expand-refs)
    (1 . od-chujiten-insert-example)))
)					; end of eval-and-compile

(eval-when-compile

(defconst odccl-gaiji-chujiten1
  (list	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil			["." ",A7(B"]
	":" 			(vector ".:" (compose-string "`:"))
	["," "(I_(B"]		["#u" ",B"(B"]
	(append odccl-start-bold '("[") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("]") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("(") '((repeat)))
	(append '(")") odccl-end-bold '((repeat)))
	"$B!A(B"		"-"
	["#'-" ",0p(B-"]	["#,-" ",0q(B-"]	["#'#=a" ",0p,D`(B"]	["#'#=e" ",0p,D:(B"]
	["#'#=i" ",0p,Do(B"]	"#$B"^(B"		["#u" ",B"(B"]	["#," ",A8(B"]
	["#,c" ",Ag(B"]	["#'#e" ",0p'(B"]	["#'#/er/" ",0p:(B"]["#'#I" ",0p!(B"]
	["#'#o" ",0p7(B"]	["#'#U" ",0p5(B"]	["#'#a" ",0p,(B"]	["#'" ",0p(B"]
	["#'E" ",AI(B"]	["#'a" ",Aa(B"]	["#'e" ",Ai(B"]	["#'i" ",Am(B"]
	["#'o" ",As(B"]	["#'u" ",0p(Bu"]	["#'#v" ",0p+(B"]	["#,#e" ",0q'(B"]
	["#,#/er/" ",0q:(B"]["#,#I" ",0q!(B"]	["#,#o" ",0q7(B"]	["#,#U" ",0q5(B"]
	["#,#a" ",0q,(B"]	["#," ",0q(B"]	["#,a" ",A`(B"]	["#,e" ",Ah(B"]
	["#,i" ",0q(Bi"]	["#,o" ",Ar(B"]	["#,u" ",0q(Bu"]	["#,#v" ",0q+(B"]
	["#v" ",0+(B"]
			["#'A" ",0p(BA"]	["#'B" ",0p(BB"]	["#'C" ",0p(BC"]
	["#'D" ",0p(BD"]	["#'E" ",0p(BE"]	["#'F" ",0p(BF"]	["#'G" ",0p(BG"]
	["#'H" ",0p(BH"]	["#'I" ",0p(BI"]	["#'L" ",0p(BL"]	["#'M" ",0p(BM"]
	["#'O" ",0p(BO"]	["#'P" ",0p(BP"]	["#'Q" ",0p(BQ"]	["#'R" ",0p(BR"]
	["#'S" ",0p(BS"]	["#'T" ",0p(BT"]	["#'U" ",0p(BU"]	["#'V" ",0p(BV"]
	["#'X" ",0p(BX"]	["#'Y" ",0p(BY"]	["#'Z" ",0p(BZ"]	["#'a" ",0p(Ba"]
	["#'e" ",0p(Be"]	["#'i" ",0p(Bi"]	["#'o" ",0p(Bo"]	["#'u" ",0p(Bu"]
	["#'y" ",0p(By"]	["#,A" ",0q(BA"]	["#,E" ",0q(BE"]	["#,I" ",0q(BI"]
	["#,O" ",0q(BO"]	["#'#/ae/" ",0p$(B"]""		["#,#/ae/" ",0q$(B"]
	""		["#/ae/" ",0$(B"]	""		["#,S" ",0q(BS"]
	["#,T" ",0q(BT"]	["#,U" ",0q(BU"]	["#,V" ",0q(BV"]	["#,a" ",0q(Ba"]
	["#,e" ",0q(Be"]	["#,i" ",0q(Bi"]	["#,o" ",0q(Bo"]))

(defconst odccl-gaiji-chujiten2
  (list	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil		["#,u" ",0q(Bu"]	["#,y" ",0q(By"]	["#~#E" ",0;(B"]
	["#~#o" ",0>(B"]	["#~#a" ",0<(B"]	["#e" ",0'(B"]	["#/er/" ",0:(B"]
	["#I" ",0!(B"]	["#o" ",07(B"]	["#U" ",05(B"]	["#t" ",0H(B"]
	["#d" ",0I(B"]	["#s" ",0L(B"]	["#g" ",0M(B"]	["#/ng/" ",0U(B"]
	"#/t/"		["$B&5(B" ",FV(B"]	"#/$B@<LgJD:?2;(B/" ; glottal stop
	[":" ",0r(B"]
	["#a" ",0,(B"]	["#l" ",B3(B"]	 "#~"		["#~a" ",Ac(B"]
	["#~n" ",Aq(B"]	["$B&U(B" ",Ax(B"]	["$B"r(B" ",AE(B"]	["#.t"	",B~(B"]
	["#$B!&(B" ",B(B"]	["#\"" ",A((B"]	["#\"O" ",AV(B"]	["#\"a" ",Ad(B"]
	["#\"e" ",Ak(B"]	["#\"i" ",Ao(B"]	["#\"o" ",Av(B"]	["#\"u" ",A|(B"]
	"#^"		["#^a" ",Ab(B"]	["#^e" ",Aj(B"]	["#^i" ",An(B"]
	["#^o" ",At(B"]	["#=" ",D/(B"]	["#=a" ",D`(B"]	["#=e" ",D:(B"]
	["#=i" ",Do(B"]	["#=o" ",Dr(B"]	["#=u" ",D~(B"]	
	(vector "#=y" (compose-string ",D/(By"))
	["#/ua/" ",Bc(B"]
	(vector "#/ue/" (compose-string ",B"(Be"))
	(vector "#/uo/" (compose-string ",B"(Bo"))
	["#/vC/" ",BH(B"]
	(vector "#/va/" (compose-string ",B7(Ba"))
	["#/vc/" ",Bh(B"]	["#/ve/" ",Bl(B"]
	(vector "#/vi/" (compose-string ",B7,C9(B"))
	["#/vr/" ",Bx(B"]	["#/vs/" ",B9(B"]	"#/om/"		["#'4" ",0p(B4"]
	["#'8" ",0p(B8"]	["#'b" ",0p(Bb"]	["#'f" ",0p(Bf"]	["#'h" ",0p(Bh"]
	["#'n" ",0p(Bn"]	["#'p" ",0p(Bp"]	["#'q" ",0p(Bq"]	["#'r" ",0p(Br"]
	["#'t" ",0p(Bt"]
	(vector "#$B!&(B1" (compose-string ",B(B1"))
	(vector "#$B!&(B3" (compose-string ",B(B3"))
	["#$B&R(B" ",Fr(B"]
	(vector "#$B!o(B" (compose-string "Y-"))
 	(vector "#$" (compose-string "$|"))
	"#/$B!l!m(B/"	["$B!&(B" "(I%(B"]	["#~N" ",AQ(B"]
	["#,E" ",0q(BE"]	["#,C" ",0q(BC"]	["#,D" ",0q(BD"]	["#,G" ",0q(BG"]
	["#,N" ",0q(BN"]	["#,P" ",0q(BP"]	["#,Q" ",0q(BQ"]	["#'/oe/" ",0p0(B"]
	""		["#/oe/" ",0=(B"]	""		["#~/oe/" ",00(B"]
	""		["^#e" "^,0'(B"]))

(defconst odccl-gaiji-chujiten3
  (list	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil
	(append odccl-start-inv '("[$BL>(B]") odccl-end-inv '((repeat)))
 	(append odccl-start-inv '("[$BBe(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B7A(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$BF0(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$BI{(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B@\(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$BA0(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B4'(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B4V(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B=u(B") '((repeat)))
	(append '("$BF0(B]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B@\(B") '((repeat)))
	(append '("$BF,(B]") odccl-end-inv '((repeat)))
	(append '("$BHx(B]") odccl-end-inv '((repeat)))
	(vector "[U]" (compose-string "$B#u""(B"))
	(vector "[C]" (compose-string "$B#c""(B"))
	(append odccl-start-inv '("($BC1(B)") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("($BJ#(B)") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[A]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[P]") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("($B<+(B)") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("($BB>(B)") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("[$B@.(B") '((repeat)))
	(append '("$B6g(B]") odccl-end-inv '((repeat)))
	"[$B2;@<(B]"
	(odccl-lookup-capfunc 'od-chujiten-insert-example
			      od-chujiten-capfunc-table)
	"[$BK\J8(B]"
	(odccl-lookup-capfunc 'od-chujiten-insert-frames-expand-refs
			      od-chujiten-capfunc-table)
	"$B!B(B"		"$B!B(B"		["[$B;2>H(B]" "$(C"Q(B"]
	["#'$B!A(B" ",0p$B!A(B"]			["#,$B!A(B" ",0q$B!A(B"]
	(vector "$B(@(B" (compose-string "$B!B(!(B"))	["~$B"-(B" "$(C"Y(B"]
	["_$B",(B" "$(C"V(B"]	"#$B"e(B"		"$BRD(B"		["#/$B8}AG(B/" "$(D5y(B"]
	["#/$B:MVu(B/" "$(D?Y(B"]["#/$B:Ms^(B/" "$(DAD(B"]["#/$B%5Ud(B/" "$(DY)(B"]["#/$B9|;a(B/" "$(Di](B"]
	"#/$BLg7n(B/"			["#'$B!D(B" ",0p$B!D(B"]
	"$B!](B"		(vector "$B"+"*(B" (compose-string "$B"+"*(B"))
	"#/fi/"		["#/$B8}0&(B/" "$(D6P(B"]["#/$B=w0f(B/" "$(D9)(B"]["#/$B:M08(B/" "$(D?x(B"]
	["#/$B:MI!(B/" "$(DA+(B"]["#/$BLZFb(B/" "$(DC.(B"]["#/$BLZH}(B/" "$(DDH(B"]["#/$BLZQ<(B/" "$(DCy(B"]
	"#/$BLZ:s(B/"	["#/$BLZWd(B/" "$(DDI(B"]"#/$B2P@P(B/"	["#/$B2P(B($B2K$NZU(B)/""$(DIt(B"]
	"$B_s(B"		["#/$B2&FG(B/" "$(DL;(B"]["#/$BQR:B(B/" "$(DM\(B"]["#/$BQRVx3-3-=w(B/" "$(DN0(B"]
	["#/$BQRVxI<(B/" "$(DMy(B"]		["#/$BJFRT(B/" "$(DSF(B"]
	["#/$B9C1)(B/" "$(DU8(B"]		["#/$Br/1)(B/" "$(DUA(B"]
	["#/$B7n@N(B/" "$(DV9(B"]["#/$B=.;3(B/" "$(DVv(B"]["#/$B%5:s(B/" "$(DXt(B"]["#/$BCn86(B/" "$(D[=(B"]
	"#/$BJ8Cn(B/"	["#/$BCn;I(B/" "$(D[6(B"]["#/$BF&9)(B/" "$(D^g(B"]["#/$BB-Jq(B/" "$(D_e(B"]
	["#/$BB-08(B/" "$(D_|(B"]["#/$BEP&B(B/" "$(DbG(B"]"#$BRD(B"		["#/$BGOTo(B/" "$(Di%(B"]
	["#/$BGO@'(B/" "$(Di@(B"]		["#/$B5{0l6R(B/" "$(DjL(B"]
	["#/$B5{@>Aa(B/" "$(DkC(B"]		["#/$B5{(B($(D[x$B$NZU(B)/" "$(DkU(B"]
	["#/$B5{:W(B/" "$(Dk9(B"]		["#/$B5{(B($BKS$NZU(B)/" "$(Djw(B"]
	["#/$B5{<c(B/" "$(Dk,(B"]["#/$B5{C`(B/" "$(Dk<(B"]["#/$B5{0P(B/" "$(Djb(B"]["#/$B5{J&(B/" "$(DjS(B"]
	["#/$B0WD;(B/" "$(Dl'(B"]		["#/$BAM8c(B/" "$(Dm5(B"]
	["($B#C(B)" "$(D"m(B"]
	["($B#R(B)" "$(D"n(B"]
	["#/$B%J%A%e%i%k(B/" "#/(IEA-WY(B/"]))

(defconst odccl-gaiji-chujiten4
  (list	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil		"#/$B!B!{!B(B/"	"#&"		"#/$B"u"u(B/"
	"#$B#X(B"	"#$B"v(B"	"$B"^(B"	"#$B"^(B"	"#$B!P(B"	"$B!A!A(B"	"$B!c(B"	"$B!d(B"
	"($BM%(B)"			["#/$B>e%U%'%k%^!<%?(B/" "#/$B>e(IL*YO0@(B/"]
	["#/thorn/" "$(D)P(B"]	"$B!B(B"
	["#/$B2<%U%'%k%^!<%?(B/" "#/$B2<(IL*YO0@(B/"]	"#/$B"$"&(B/"
	"$B!y(B"			"$B!h(B"
	"$B"h(B"			(vector "#$B!b(B" (compose-string "$B("!a(B"))
	["#/$BLZ>e2<(B/" "$(DC_(B"]	["#/$BLZN_(B/" "$(DDu(B"]
	["#/$BLZL5(B/" "$(DE&(B"]["#/$BC]A<(B/" "$(DRd(B"]["#/$B%5O,(B/" "$(DY4(B"]["#/$B%5HK(B/" "$(DZ0(B"]
	["#/$B5{SE(B/" "$(DkE(B"]["#/$B5{Tr(B/" "$(Djd(B"]["#/$B5{gP(B/" "$(DkS(B"]["#/$B5{H?(B/" "$(DjI(B"]
	"#/$B5{2V(B/"		["#/$B68D;(B/" "$(Dkt(B"]))

(defun odccl-make-ccl-chujiten (&optional key)
  (odccl-make-ccl
   (odccl-make-low-tables
    (append
     (odccl-low-alist-japanese key)
     (list (cons 161
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-chujiten1 key)))))
	   (cons 162
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-chujiten2 key)))))
	   (cons 163
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-chujiten3 key)))))
	   (cons 164
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-chujiten4 key))))))))))

)					; end of eval-when-compile

;(defconst od-ccl-chujiten (odccl-compile odccl-make-ccl-chujiten))

(odccl-define od-ccl-chujiten-x (ccl-compile (odccl-make-ccl-chujiten 'x)))

(odccl-define od-ccl-chujiten-nw (ccl-compile (odccl-make-ccl-chujiten)))

(defvar od-chujiten-not-example-header-regexp "\C-l\\| +[^ (I%$B!&(B]")

(defun od-eiwachujiten-compute-fill-prefix ()
  (save-excursion
    (while (eolp)
      (forward-char))
    (cond ((looking-at
	    " +\\([A-Z]?[1-9][0-9]?[a-z]? \\|[a-z] \\|[(I%$B!&(B]\\|[$B!](B]\\|([1-9][0-9]?)\\)")
;;;	   (goto-char (match-end 0))
;;;	   (concat "$B!!(B" (make-string (- (current-column) 2) ?\ )))
;;	   (goto-char (match-beginning 0))
;;	   (concat "$B!!(B" (make-string (+ (current-column) 3) ?\ )))
	   "$B!!(B   ")
	  ((>= (current-indentation) 2)
	   (concat "$B!!(B"
		   (make-string (- (current-indentation) 2) ?\ )))
	  (t
	   nil))))

(defun od-waeichujiten-compute-fill-prefix ()
  "$B!!(B   ")

;; This is a dirty quick hack; should be cleaned up.
(defun od-chujiten-insert-frames-expand-refs (fno ofs)
  (delete-region (point) (progn (beginning-of-line) (point)))
  (let ((page 1) ref-list)
    (save-restriction
      (narrow-to-region (point) (point))
      (indent-rigidly (point)
		      (progn (od-insert-frames fno ofs) (point)) 1)
      (delete-region (point) (progn (beginning-of-line) (point)))
      (setq ref-list (nreverse (od-collect-references)))
      (goto-char (point-max)))
    (save-excursion
      (while ref-list
	(let ((ref (car ref-list)))
	  (if (eq (car (cdr ref)) 'od-show-entry)
	      (progn
		(message "expanding references '%s'..." (car ref))
		(goto-char (point-max))
		(insert ?\n ?\C-l ?\n)
		(indent-rigidly
		 (point)
		 (progn (apply 'od-insert-frames (cdr (cdr ref))) (point)) 1)
		(setcdr (cdr ref) (list od-base-fno od-base-ofs page))
		(setq page (1+ page))
		(setq references (cons ref references)))))
	(setq ref-list (cdr ref-list)))))
  (message "collecting references..."))

;(defun od-chujiten-insert-frames (fno ofs)
;  (forward-char)
;  (save-excursion
;    (indent-rigidly (point)
;		    (progn (od-insert-frames fno ofs) (point) 1))
;    (delete-region (point) (progn (beginning-of-line) (point)))))

(defun od-chujiten-insert-example (fno ofs)
  (if (= (preceding-char) ?.) (delete-char -1))
  (insert "$B!'(B")
  (forward-char)
  (let ((start (point))
	(prefix (if od-use-only-ascii-and-jisx0208
		    "    $B!&(B" "    (I%(B")))
    (od-insert-frames fno ofs)
    (delete-region (point) (progn (beginning-of-line) (point)))
    (save-restriction
      (narrow-to-region start (1- (point)))
      (goto-char start)
      (while (re-search-forward "^" nil t)
	(replace-match prefix nil nil)))
    (goto-char start)))

;; Some accented vowels that have different meanings are overloaded to
;; a single code: both ",Ai(B" in a word "caf,Ai(B" and ",0p(Be" in its phonetic
;; sign "k,0$(Bf,0p(Be,0!(B" are assigned to 0xa14b.  To distinguish them,
;; characters enclosed with slashes(/.../) are treated as phonetic
;; ones, otherwise as accented letters.
(defconst od-chujiten-convert-phonetic-table
  '((?,Ah(B . ",0q(Be") (?,Ai(B .  ",0p(Be") (?,Am(B . ",0p(Bi") (?,Ar(B . ",0q(Bo") (?,As(B . ",0p(Bo")))

(defconst od-chujiten-convert-phonetic-regexp
  "[,Ahimrs(B]")

(defun od-chujiten-convert-phonetic-accent ()
  (if (not od-use-only-ascii-and-jisx0208)
      (let ((mc-flag t) (enable-multibyte-characters t)
	    (end-marker (make-marker))
	    case-fold-search start end)
	(goto-char (point-min))
	(while (setq start (search-forward "/" nil t))
	  (if (and (setq end (re-search-forward "/\\|$" nil t))
		   (= (preceding-char) ?/))
	      (progn
		(goto-char start)
		(set-marker end-marker end)
		(while (re-search-forward od-chujiten-convert-phonetic-regexp
					  end-marker 'move-to-limit)
		  (replace-match (cdr
				  (assq (char-after (match-beginning 0))
					od-chujiten-convert-phonetic-table))
				 nil nil))))))))

(od-modify-dict-parameters
 "eiwa"
 (nconc
  (list (cons 'summary
	      (cons od-chujiten-not-example-header-regexp
		    "\\($B!'(B$\\|\^M\\)"))
	(cons 'capfunc-table od-chujiten-capfunc-table))
  '((pretty-name . "$B?71QOBCf<-E5(B")
    (ccl . (od-ccl-chujiten-x . od-ccl-chujiten-nw))
    (japanese-input . nil)
    (filter-func-list
     . (od-chujiten-convert-phonetic-accent 
	od-convert-one-digit-superscript od-filter-buffer))
    (filter-regexp-list . nil)
    ;; (fill-function . default)
    (compute-fill-prefix-func . od-eiwachujiten-compute-fill-prefix)
    (header-column . nil)
    (secondary-dictionary . ((?k . "waei") (?K . "waei")))
    (strip-stress-on-isearch . t))))

(od-modify-dict-parameters
 "waei"
 (nconc
  (list (cons 'summary
	      (cons od-chujiten-not-example-header-regexp
		    "\\($B!'(B$\\|\^M\\)"))
	(cons 'capfunc-table od-chujiten-capfunc-table))
  '((pretty-name . "$B?7OB1QCf<-E5(B")
    (ccl . (od-ccl-chujiten-x . od-ccl-chujiten-nw))
    (japanese-input . t)
    (filter-func-list
     . (od-convert-one-digit-superscript od-filter-buffer))
    (filter-regexp-list . nil)
    ;; (fill-function . default)
    (compute-fill-prefix-func . od-waeichujiten-compute-fill-prefix)
    (header-column . nil)
    (secondary-dictionary . ((?a . "eiwa") (?A . "eiwa")))
    (strip-stress-on-isearch . t))))

(od-add-title-name "	   $B8&5f<R(B $B?71QOBCf<-E5(B($BBh(B6$BHG(B)$B!&?7OB1QCf<-E5(B($BBh(B4$BHG(B)")

;;; od-chujiten.el ends here
