;;; -*-byte-compile-dynamic: t;-*-
;;; od-oxford.el --- dictionary-dependent file (Sansyusya the CONCICE Oxford Dictionary and Oxford thesaurus)
;; Author: MITA Yoshio <mita@jp.FreeBSD.org>
;; This file is created for Sanseido EBG book ISBN4-384-00413-3
(eval-when-compile

(defconst odccl-gaiji-oxford
  (list
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	" "	"!"	"$B"*(B"	"" 	"$"	"%"	"&"	"'"
	"("	")"	"*"	"+"	","	"-"	"."	"/"
	;
	(append odccl-start-bold '("0") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("1") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("2") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("3") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("4") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("5") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("6") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("7") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("8") odccl-end-bold '((repeat)))
	(append odccl-start-bold '("9") odccl-end-bold '((repeat)))
	[":" ",0r(B"]	";"	"<"	"="	">"	"?"	"@"
	"A"	"B"	"C"	"D"	"E"	"F"	"G"
	"H"	"I"	"J"	"K"	"L"	"M"	"N"	"O"
	"P"	"Q"	"R"	"S"	"T"	"U"	"V"	"W"
	"X"	"Y"	"Z"	"\["	"\\"	"\]"	"^"	"_"
	;
	"'"	"a"	"b"	"c"	"d"	"e"	"f"	"g"
	"h"	"i"	"j"	"k"	"l"	"m"	"n"	"o"
	"p"	"q"	"r"	"s"	"t"	"u"	"v"	"w"
	"x"	"y"	"z"	"{"	"|"	"$B"`(B"	"~"	nil
;;;["#^u" ",A{(B"]	["#^u" ",A{(B"]	"$B"`(B"	"$B!>(B"	["#~n" ",Aq(B"]
	;
	["#'u" ",Az(B"]	["#\"u" ",A|(B"]	["#'e" ",Ai(B"]	["#^a" ",Ab(B"]
	["#\a" ",Ad(B"]	["#`a" ",A`(B"]	["#^i" ",An(B"]	["#,c" ",Ag(B"]
	;
	["#^e" ",Aj(B"]	["#^o" ",At(B"]	["#`e" ",Ah(B"]	["#\"i" ",Ao(B"]
	(vector "#^#-a" (compose-string "^,D`(B")) 
	["#vC" ",Bh(B"]	["#vC" ",Bh(B"]	["#'a" ",Da(B"]
	;
	["'" ",0p(B"]	["1" ",A9(B"]	["2" ",A2(B"]	["3" ",A3(B"]
	(append odccl-start-inv '("4") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("5") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("6") odccl-end-inv '((repeat)))
	["#a" ",0,(B"]	["#~#a" ",0<(B"]	["#`o" ",Mr(B"]	["#'i" ",Mm(B"]   
	"$B"a(B"	["(R)" ",A.(B"]
	(append odccl-start-inv '("$B#D(B") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("$B#T(B") odccl-end-inv '((repeat)))
	["#\"o" ",Mv(B"]	["," ",0q(B"]
	(append odccl-start-inv '("1") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("2") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("3") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("4") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("5") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("6") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("7") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("8") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("9") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("+") odccl-end-inv '((repeat)))
	(append odccl-start-inv '("-") odccl-end-inv '((repeat)))
	["#\"e" ",Ak(B"]	["#\"A" ",AD(B"]	["#/ae/" ",Af(B"]	["#'o" ",As(B"]
	;
	["#z,0Q(B" ",0M(B"]	["$B"i(B" ",0L(B"]	["#ng" ",0U(B"]	["$B&H(B" ",0H(B"]
	["#d,0Q(B" ",0I(B"]	["#/ae/" ",Af(B"]
	["#/ui/" ",0!(B"]	["#e" ",0'(B"]
	["#a" ",08(B"]	["#,0RQ6(B" ",05(B"]	["#,0G(B" ",0+(B"]	["#3" ",0M(B"]
	["#c" ",07(B"]	["#~c" ",0>(B"]	["#/,06(BA/" ",ME(B"]	["#/uU/" ",C](B"]
	["#`a" ",A`(B"]	"a"	"b"	"c"	"d"	"e"	"f"	"g"
	"h"	"i"	"j"	"k"	"l"	"m"	"n"	"o"
	"p"	"q"	"r"	"s"	"t"	"u"	"v"	"w"
	"x"	"y"	"z"	["#'e" ",Ai(B"]
	["#,c" ",Ag(B"]	["#`e" ",Ah(B"]	["#^e" ",Aj(B"]	["#^a" ",Ab(B"]
	["#\"a" ",Ad(B"]	"A"	"B"	"C"	"D"	"E"	"F"	"G"
	"H"	"I"	"J"	"K"	"L"	"M"	"N"	"O"
	"P"	"Q"	"R"	"S"	"T"	"U"	"V"	"W"
	"X"	"Y"	"Z"	["#\u" ",A|(B"]
	["#^i" ",An(B"]	["#^o" ",At(B"]	["#~n" ",Aq(B"]	nil
))


(defun odccl-make-ccl-oxford (&optional key)
  (odccl-make-ccl
   (` ((branch r1 (,@ (odccl-select odccl-gaiji-oxford key)))))
   'fully-specified))

)					; end of eval-when-compile

;(defconst od-ccl-oxford (odccl-compile odccl-make-ccl-oxford))

(odccl-define od-ccl-oxford-x (ccl-compile (odccl-make-ccl-oxford 'x)))

(odccl-define od-ccl-oxford-nw (ccl-compile (odccl-make-ccl-oxford)))

(defvar od-oxford-not-example-header-regexp " +[^ (I%$B!&(B]")
(defvar od-oxford-example-header-regexp " +[(I%$B!&(B]")

;;;(defun od-filter-oxford ()
;;;  (let (
;;;;	(progn
;;;;	  (goto-char 1))
;;;;	(start-point (point))
;;;;	(end-marker (make-marker))
;;;	(previous-pos (point))
;;;	(previous-face 'default)
;;;	(bold (if (internal-find-face 'od-bold) 'od-bold 'bold))
;;;	(inverse (if (internal-find-face 'od-inverse) 'od-inverse 'modeline))
;;;	(bold-inverse (if (internal-find-face 'od-bold-inverse)
;;;			  'od-bold-inverse 'od-bold-inverse-default)))
;;;    (progn
;;;	(goto-char 1)
;;;	(while (search-forward "\e\[" nil t)
;;;	  (let ((face
;;;		 (cond ((looking-at "0m")
;;;			(delete-region (- (point) 2) (+ (point) 2))
;;;			  'default)
;;;			 ((looking-at "1m")
;;;			  (delete-region (- (point) 2) (+ (point) 2))
;;;			  'bold)
;;;			 ((looking-at "7m")
;;;			  (delete-region (- (point) 2) (+ (point) 2))
;;;			  'inverse)
;;;			 ((looking-at "1;7m")
;;;			  (delete-region (- (point) 2) (+ (point) 4))
;;;			  'bold-inverse)
;;;			 (t
;;;			  nil))))
;;;	      (if face
;;;		  (progn
;;;		    (if (not (eq previous-face 'default))
;;;			(add-text-properties previous-pos (point)
;;;					     (list 'face previous-face
;;;						   'rear-nonsticky '(face))))
;;;		    (setq previous-pos (point)
;;;			  previous-face face)))))
;;;	 )
;;;))

(defun od-oxford-compute-fill-prefix ()
  (save-excursion
    (while (eolp)
      (forward-char))
    (cond ((looking-at
	    " +\\([A-Z]?[1-9][0-9]?[a-z]? \\|[a-z] \\|[(I%$B!&(B]\\|[$B!](B]\\|([1-9][0-9]?)\\)")
;;;	   (goto-char (match-end 0))
;;;	   (concat "$B!!(B" (make-string (- (current-column) 2) ?\ )))
;;	   (goto-char (match-beginning 0))
;;	   (concat "$B!!(B" (make-string (+ (current-column) 3) ?\ )))
	   "$B!!(B   ")
	  ((>= (current-indentation) 2)
	   (concat "$B!!(B"
		   (make-string (- (current-indentation) 2) ?\ )))
	  (t
	   nil))))

(od-modify-dict-parameters
 "oxford"
 (cons
  (cons 'summary
	(cons od-oxford-not-example-header-regexp
	      "\\($B!'(B$\\|\^M\\)"))
  '((pretty-name . "$B%3%s%5%$%91Q1Q<-E5(B")
    (ccl . (od-ccl-oxford-x . od-ccl-oxford-nw))
    (japanese-input . nil)
    (filter-func-list
     . (od-convert-one-digit-superscript
;;	od-filter-oxford
	od-filter-buffer))
    (filter-regexp-list . nil)
    ;; (fill-function . default)
    (compute-fill-prefix-func . od-oxford-compute-fill-prefix)
    (header-column . nil)
    (secondary-dictionary . ((?a . "oxford") (?A . "oxford"))))))

(od-add-title-name "	         $B;0=$<R%3%s%5%$%91Q1Q<-E5!&%7%=!<%i%9N`5A8l<-E5(B")
;;; od-oxford.el ends here

