;;; -*-byte-compile-dynamic: t;-*-
;;; od-readers.el --- dictionary-dependent file (Kenkyusya readers English-Japanese)
;; Author: MITA Yoshio <mita@jp.FreeBSD.org>
;; This file is created for Kenkyusya Readers EBXA book ISBN4-7674-3530-7.
(eval-when-compile

(defconst odccl-gaiji-readers1
  (list
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	[ "#e" ",0'(B"]	[":" ",0r(B"]	["#',0%(B" ",Aa(B"]
	["#'o" ",As(B"]	["'e" ",Ai(B"]	["'i" ",Am(B"]	["'e" ",Ai(B"]
	;
	["'i" ",Am(B"]	["*" ",A$(B"]	["#`a*" ",A`(B"]	["#`o" ",Ar(B"]
	(vector "#'a" (compose-string ",A4,0,(B"))
	(vector "#'#/ae/" (compose-string ",A4,0$(B"))
	["'i" ",Am(B"]
	["'u" ",Az(B"]
	;
	["`e" ",Ah(B"]	["\"" ",A((B"]	["`u" ",Ay(B"]	["'u" ",Az(B"]
	["'a" ",Aa(B"]	["`e" ",Ah(B"]	["$B"i(B" ",0L(B"]	["#'o" ",As(B"]
	;
	["`i" ",Al(B"]
        (vector "#'#,06(B" (compose-string ",A4,07(B"))
	["a" ",0,(B"]
	(vector "#`#/ae/" (compose-string "`,0$(B"))
	(vector "#'#v" (compose-string ",A4,0+(B"))
	(vector "#`a" (compose-string "`,0,(B"))
	["#/ng/" ",0U(B"]	["#/ae/" ",Af(B"]
	;
	["#`a*" ",A`(B"]	["$B&H(B" ",0H(B"] 
        (vector "#'#e" (compose-string ",A4,0'(B")) 
	["#o" ",07(B"]	["#'y" ",A}(B"]	["#`o" ",Ar(B"]
        (vector "#`#,06(B" (compose-string "`,07(B"))
	(vector "#`y" (compose-string "`,0-(B"))
	;
	["`u" ",Ay(B"]	["#g" ",0M(B"]	["#E" ",0#(B"]	["#e" ",D:(B"]
	["#-o" ",Dr(B"]	["#'A" ",AA(B"]	["#~a" ",0<(B"]	["#'l" ",Be(B"]
	;
	["#/dh/" ",0I(B"]
	(vector "#`#v" (compose-string "`,0+(B"))
	[ "#v" ",0+(B"]
        (vector "#`#e" (compose-string "`,0'(B")) 
	[ "#'E" ",AI(B"]	[ "#~#c" ",0>(B"]	[ "#-a" ",D`(B"]
	(vector "#'#-U" (compose-string ",A4,D^(B"))
	;
	[ "#-i" ",Do(B"]	[ "#\"u" ",A|(B"]	["#,c" ",0N(B"] 	["#~E" ",0;(B"]
	["#\"" ",Av(B"]	[ "#'E" ",AI(B"]	["#/oe/" ",00(B"]
        (vector "#-#/ae/" (compose-string ",D/,Af(B")) 
	;
	["#-u" ",D~(B"]	["#/,06(B" ",0/(B"]	["#\"a" ",Ad(B"]	["#'U" ",AZ(B"]
	["#`A" ",A@(B"]	["#^a" ",Ab(B"]	["#~n" ",Aq(B"]	["#'y" ",A}(B"]
	;
	["#\"e" ",Ak(B"]	["#^O" ",AT(B"]
        (vector "#'#e" (compose-string ",A4,0#(B")) 
	["#^e" ",Aj(B"]	["#/,0ES(B/" ",0T(B"]
	["#\"i" ",Co(B"]
	(vector "#-y" (compose-string ",D/,0-(B"))
	["#~a" ",Ac(B"]
	;
	["#\"U" ",A\(B"]	["#h" ",0](B"]	["#^i" ",An(B"]	["#`E" ",AH(B"]
	["#^u" ",A{(B"]
	(vector "#`#-U" (compose-string "`,D^(B"))
	["#`E" ",AH(B"]
	(vector "#'/o" (compose-string ",A4,0/(B"))
	;
	(vector "#\"#-U" (compose-string ",A(/(BU"))
	["#'A" ",AA(B"]	["#oA" ",Ae(B"]
	(vector "#^l" (compose-string "^l"))
	["#/l" ",B3(B"]
	(vector "#mo" (compose-string "m,0q(B"))
	["#`A" ",A@(B"]
))

(defconst odccl-gaiji-readers2
  (list	
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	["#~U" ",D](B"]
	(vector "#`l" (compose-string "`,C9(B"))	["#`U" ",AY(B"]
	["#^E" ",AJ(B"]	["#,C" ",AG(B"]	["#~/,06"(B/" ",0=(B"]	["#^C" ",BH(B"]
	;
	["#~a" ",Ac(B"]	["#'U" ",AZ(B"]
	(vector "#-l" (compose-string "-l"))
	(vector "#'~v" (compose-string ",A4(B~,0+(B"))
	["#,e" ",Dj(B"]
	(vector "#~/ae/" (compose-string "~,Af(B"))
	["#/L" ",B#(B"]	["#phi" ",FV(B"]
	;
	"?"	"`"	["#,S" ",M^(B"]	["#,s" ",C:(B"]
	"$B"^(B"	["#y" ",0[(B"]	["#,s" ",M~(B"]
	(vector "#.r" (compose-string ".r"))
	;
	(vector "#'#m" (compose-string ",A4,0^(B"))
	(vector "#.#'u" (compose-string ".,Az(B"))
	["'" ",A4(B"]	"`"	["\"" ",A((B"]
	["#a," ",B1(B"]	"~"	["#^" ",B7(B"]
	;
	["#^" ",B"(B"]	["#." ",C0(B"]	["#,t" ",B~(B"]
))

(defconst odccl-gaiji-readers3
  (list	
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	nil	nil	nil	nil	nil	nil	nil
	nil	
	"$B!](B"	"/$B9|@N(B/"	"$B!A(B"	"$B!](B"
	"($B$d$^$$$@$l$KGB(B)"
	(vector "/$B!-!>(B/" (compose-string "$B!-!>(B"))
	(vector "/$B!-!](B/" (compose-string "$B!-!](B"))
	(vector "/$B!.!](B/" (compose-string "$B!.!](B"))
	;
	(vector "/$B!.!>(B/" (compose-string "$B!.!>(B"))
	"$B!](B"	"$B!A(B"	"/$B%&%kAc(B/"
	(vector "/$B!-!A(B/" (compose-string "$B!-!A(B"))
	"#$B"^(B"	"($BAp$+$s$`$j$K:s(B)"
	;
	["/$B#A#E(B/" ",AF(B"]	"($B2PJP$K2K$NZU(B)"
	"/$B2P@P(B/"	"#$B#s(B"	"/$B;e6g(B/"
	(append odccl-start-inv '("CE") odccl-end-inv '((repeat)))
	"$B#R(B"	["#|o" ",A~(B"]
	["#$B&8(B" ",05(B"]	(vector "/$B!-!A(B/" (compose-string "$B!-!A(B"))
	"$B"M(B"	"$B"e(B"	"/$B%U%'%k%^!<%?(B/"	["$B!x(B" ",A'(B"]
	"$B!>(B"	["hbar" ",C1(B"]
	;
	"($B3V$NZU$K1)(B)"	"/$BLgCn(B/"	"/$B2<%U%'%k%^!<%?(B/"
	"/$BV_M8(B/"	"($B$5$s$:$$$K>O(B)"
	"$B5URD(B"	"$B#X(B"	"/$B%J%A%e%i%k(B/"
	;
	["(R)" ",A.(B"]	["#e|" ",0:(B"]	["D" ",AP(B"]	["#?" ",A?(B"]
	["'i" ",Am(B"]	["f" "f"]	["," ",A8(B"]
	(vector "/$B!.!A(B/" (compose-string "$B!.!A(B"))
	;
	"($B<jJP$KJ;$NZU(B)"	"/$B2P9M(B/"	"($BMK$NZU(B)/"
	"($BEP$K$*$*$6$H(B)"	"($B$5$s$:$$$K85(B)"
	"($B$5$s$:$$$KV_ED(B)"
	"#F"	"/$B6b3'(B/"
	;
	(vector "/$B!_#P(B/" (compose-string ",AW(BP"))
	["(C)" ",A)(B"]
	"($BAp$+$s$`$j$KKa(B)"
	"($B%T!<%9%^!<%/(B)"
	"#$BIT(B"	"($BHV$K$*$*$6$H(B)"	"/$BB-Bf(B/"	"($B$5$s$:$$$K0](B)"
	;
	["#p" ",A^(B"]
	))

(defun odccl-make-ccl-readers (&optional key)
  (odccl-make-ccl
   (odccl-make-low-tables
    (append
     (odccl-low-alist-japanese key)
     (list (cons 177
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-readers1 key)))))
	   (cons 178
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-readers2 key)))))
	   (cons 193
		 (` (read-branch
		     r2
		     (,@ (odccl-select odccl-gaiji-readers3 key)))))
	   )))))


)					; end of eval-when-compile

;(defconst od-ccl-readers (odccl-compile odccl-make-ccl-readers))

(odccl-define od-ccl-readers-x (ccl-compile (odccl-make-ccl-readers 'x)))

(odccl-define od-ccl-readers-nw (ccl-compile (odccl-make-ccl-readers)))

(defvar od-readers-not-example-header-regexp " +[^ (I%$B!&(B]")
(defvar od-readers-example-header-regexp " +[(I%$B!&(B]")

(defun od-filter-readers ()
  (let ((head (concat "^" od-readers-not-example-header-regexp))
	(tail (concat "\n" od-readers-example-header-regexp)))
    (goto-char 1)
    (while (re-search-forward head nil t)
      (end-of-line)
      (if (looking-at tail)
	  (insert "$B!'(B")))))

(defun od-readers-compute-fill-prefix ()
  (save-excursion
    (while (eolp)
      (forward-char))
    (cond ((looking-at
	    " +\\([A-Z]?[1-9][0-9]?[a-z]? \\|[a-z] \\|[(I%$B!&(B]\\|[$B!](B]\\|([1-9][0-9]?)\\)")
;;;	   (goto-char (match-end 0))
;;;	   (concat "$B!!(B" (make-string (- (current-column) 2) ?\ )))
;;	   (goto-char (match-beginning 0))
;;	   (concat "$B!!(B" (make-string (+ (current-column) 3) ?\ )))
	   "$B!!(B   ")
	  ((>= (current-indentation) 2)
	   (concat "$B!!(B"
		   (make-string (- (current-indentation) 2) ?\ )))
	  (t
	   nil))))

(od-modify-dict-parameters
 "readers"
 (cons
  (cons 'summary
	(cons od-readers-not-example-header-regexp
	      "\\($B!'(B$\\|\^M\\)"))
  '((pretty-name . "$B%j!<%@!<%:1QOB<-E5(B")
    (ccl . (od-ccl-readers-x . od-ccl-readers-nw))
    (japanese-input . nil)
    (filter-func-list
     . (od-convert-one-digit-superscript
	od-filter-readers od-filter-buffer))
    (filter-regexp-list . nil)
    ;; (fill-function . default)
    (compute-fill-prefix-func . od-readers-compute-fill-prefix)
    (header-column . nil)
    (secondary-dictionary . ((?a . "readers") (? . "readers"))))))

(od-add-title-name "		        $B8&5f<R%j!<%@!<%:1QOB<-E5(B ")

;;; od-readers.el ends here

