;;; sirup-doc.el --- Documents of sirup.el

;; Author: YAMAMOTO Mitsuharu <mituharu@math.s.chiba-u.ac.jp>
;; Created: 22 Dec 1997
;; Version: 1.0
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, you can either send email to this
;; program's author (see above or write to:
;;
;;              The Free Software Foundation, Inc.
;;              675 Mass Ave.
;;              Cambridge, MA 02139, USA.
;;

;;; Code:

(require 'sirup)

(defun sirup-show-system-document (dno buffer parent-point)
  (set-buffer buffer)
  (if (sirup-process-busy-p sirup-process)
      (progn
	(message "Process %s is busy.  Waiting..."
		 (process-name sirup-process))
	(while (progn (accept-process-output sirup-process)
		      (sirup-process-busy-p sirup-process)))
	(message "")))
  (widen)
  (goto-char parent-point)
  (let (buffer-read-only)
    (sirup-end-of-page)
    (if (not (eobp))
	(forward-char -1))
    (delete-region (point) (point-max))
    (if (not (bobp))
	(insert (format "\n\f%d\t[" parent-point)
		(sirup-heading-around (1- parent-point)) "]\n\n"))
    (insert (documentation (intern (concat "sirup-doc-" dno))) ?\n))
  (set-buffer-modified-p nil)
	(sirup-show-buffer nil nil
			   (save-excursion
			     (sirup-beginning-of-page)
			     (if (/= (point) 1)
				 (progn (forward-line 2) (point))))))

(defun sirup-doc-000 ()
  "$B;H$$$+$?(B --- $B=i5iJT(B ($B%-!<3d$jEv$F$OI8=`@_Dj$G$N$b$N$G$9!#(B)

  $B"!=*N;!&CfCG(B
    `M-q' (Quit $B$H3P$($k(B)$B$G=*N;$7$^$9!#;HMQ$7$?%P%C%U%!$r:o=|$7!"%5!<(B
    $B%P$H$N@\B3$b@ZCG$7$^$9!#(B
    `C-q' $B$OCfCG$G$9!#%P%C%U%!$O:o=|$5$l$^$;$s$7!"%5!<%P$H$N@\B3$b@ZCG(B
    $B$5$l$^$;$s$,!"(B(Emacs$B$N0UL#$G$N(B)$B%&%$%s%I%&$rJD$8$^$9!#(B

  $B"!=i4|2hLL$KLa$k(B
    `C-t' (Title $B$H3P$($k(B)$B$G=i4|2hLL$KLa$j$^$9!#(B

  $B"!%Z!<%8$N%9%/%m!<%k(B
    `SPC' $B$H(B `DEL' $B$G%Z!<%8$r$=$l$>$l=gJ}8~!"5UJ}8~$K%9%/%m!<%k$9$k$3(B
    $B$H$,$G$-$^$9!#(B

  $B"!<-=q$N@Z$j49$((B
    `C-d' (Dictionary $B$H3P$($k(B)$B$G<-=q$N@Z$j49$($r9T$$$^$9!#$5$i$K<-=q(B
    $BL>$rF~NO$7$F$/$@$5$$!#(B

  $B"!C18l$N8!:w(B
    $BC18l$r8!:w$9$k$K$O!"$^$:(B `C-j' $B$r%?%$%W$7$^$9!#F~NO$r5a$a$i$l$^$9(B
    $B$N$G!"!V%Q%?!<%s!W$rF~NO$7$^$9!#F|K\8l$NF~NO$N$7$+$?$O!"IaCJ;H$o$l(B
    $B$F$$$kF~NO%a%=%C%I$N%_%K%P%C%U%!$K$*$1$kF~NOK!$K=`$8$^$9!#(B

    $B$3$3$G$$$&!V%Q%?!<%s!W$H$O!"8!:w$7$?$$8l!"$^$?$O$=$N@hF,$+:G8e$K!"(B
    `*'($B$^$?$O(B`$B!v(B')$B$rIU$1$?$b$N$N$3$H$G$9!#@hF,$K(B`*'$B$rIU$1$k$H!"8eJ}0l(B
    $BCW8!:w$K$J$j!":G8e$K(B`*'$B$rIU$1$k$H!"A0J}0lCW8!:w$K$J$j$^$9!#(B

  $B"!%j%s%/$r$?$I$k(B
    <..:..>$B$N7A$r$7$?$b$N$OB>$N%Z!<%8$X$N%j%s%/$G$9!#(B(.. $B$NItJ,$K$O(B 0$B!A(B
    9 $B$N?t;z$+(B a$B!A(Bf $B$N%"%k%U%!%Y%C%H$NNs$,$-$^$9!#(B)
    $B$?$I$j$?$$%j%s%/$NItJ,$K%+!<%=%k$r0\F0$7$?8e!"(B`RET' $B$G$=$N%j%s%/$r(B
    $B$?$I$k$3$H$,$G$-$^$9!#(B($B%j%s%/0J30$N>l=j$G(B `RET' $B$r%?%$%W$9$k$H!"%+!<(B
    $B%=%k0LCV$N8l$r=i4|F~NO$H$7$F%Q%?!<%s$NF~NO$,$G$-$^$9!#(B)
    $B%j%s%/$NItJ,$K%+!<%=%k$r0\F0$5$;$k$K$O!"0J2<$N%-!<$,JXMx$G$9!#(B

    `TAB'   `C-i'         ... $B<!$N%j%s%/$N0LCV$K%+!<%=%k$r0\F0$5$;$k!#(B
    `M-TAB' `M-C-i' `C-o' ... $BA0$N%j%s%/$N0LCV$K%+!<%=%k$r0\F0$5$;$k!#(B

  $B"!%j%s%/$N;2>H85$N%Z!<%8$K$b$I$k(B
    $B%j%s%/$r$?$I$C$?8e!"0JA0$N%Z!<%8$KLa$j$?$$$H$-$O(B `^' $B$r%?%$%W$7$^(B
    $B$9!#$9$k$H$?$I$C$?%j%s%/$N0LCV$K%+!<%=%k$,0\F0$7$^$9!#(B`^' $B$N8e$G$b(B
    $B$&0lEY;2>H@h$NJ}$KLa$j$?$$$H$-$O(B($B$=$N>l$G(B `RET' $B$G$b$G$-$^$9$,(B)$B!"(B
    `_' $B$r%?%$%W$7$^$9!#(B

($B=i5iJT=*$j(B)"
  nil)

(defun sirup-doc-001 ()
  "$B;H$$$+$?(B --- $BCf5iJT(B ($B%-!<3d$jEv$F$OI8=`@_Dj$G$N$b$N$G$9!#(B)

  $B"!%Q%?!<%s$NF~NO(B
    $B=i5iJT$G=R$Y$?(B `C-j' $B$NB>$K!"0J2<$N$h$&$J%-!<$K$h$C$F$b%Q%?!<%s$N(B
    $BF~NO$,9T$($^$9!#(B

    `a'..`z', `*' ... $BF~NO$5$l$?%-!<$r%Q%?!<%s$N:G=i$NJ8;z$H$7$^$9!#(B
    `C-y'         ... $BDL>o(B `C-y' $B$G%d%s%/$5$l$k%F%-%9%H$r%Q%?!<%s$N=i(B
                      $B4|F~NO$H$7$^$9!#(B
    `C-\\'         ... $BDL>o(B `C-\\' $B$G5/F0$5$l$k(B($BF|K\8l(B)$BF~NO%a%=%C%I$r!"(B
                      $B%Q%?!<%s$NF~NOA0$K5/F0$5$;$^$9!#F~NO%a%=%C%I$N<o(B
                      $BN`$d!"(BEmacs $B$N%P!<%8%g%s$K$h$C$F$O$&$^$/$$$+$J$$(B
                      $B>l9g$b$"$j$^$9!#(B

  $B"!%Z!<%8$N0\F0(B
    $B$"$k%Z!<%8$N>e$N%j%s%/$r$?$I$C$FJL$N%Z!<%8$K0\F0$7$?>l9g!";2>H85$N(B
    $B%Z!<%8$r!V?F%Z!<%8!W!";2>H@h$N%Z!<%8$r!V;R%Z!<%8!W$H8F$V$3$H$K$7$^(B
    $B$9!#$9$k$H!"!V?F%Z!<%8!W$KJ#?t$N%j%s%/$,$"$k$H$-!"$3$l$i$N%j%s%/$N(B
    $B;2>H@h$O$-$g$&$@$$$N4X78$K$"$j$^$9!#(B

    $BNc(B:
                     +-($B;R(B)-> $B!V;H$$$+$?=i5iJT!W(B
                     |                $B",(B
                     |      ($B$R$H$D>e$N$-$g$&$@$$(B)
                     |                $B!C(B
       $B!V=i4|2hLL!W(B--+-($B;R(B)-> $B!V;H$$$+$?Cf5iJT!W(B
                     |                $B!C(B
                     |      ($B$R$H$D2<$N$-$g$&$@$$(B)
                     |                $B"-(B
                     +-($B;R(B)-> $B!V;H$$$+$?>e5iJT!W(B

    $B$3$N$H$-!"(B`<' $B$G$R$H$D>e$N$-$g$&$@$$$N%Z!<%8$K!"(B`>' $B$G$R$H$D2<$N$-$g(B
    $B$&$@$$$N%Z!<%8$K0\F0$9$k$3$H$,$G$-$^$9!#0J>e$^$H$a$k$H!"(B

                      $B?F%Z!<%8(B
                        `^'                           `M-u'
      $B>e$N$-$g$&$@$$(B `<' + `>' $B2<$N$-$g$&$@$$(B     `M-p' + `M-n'
                        `_'                           `M-d'
                      $B;R%Z!<%8(B

    $B$H$J$j$^$9!#1&B&$N(B4$B$D$N%-!<$O!":8B&$N%-!<$NBP1~$9$k0LCV$K$"$k$b$N(B
    $B$HF1$8F/$-$r$7$^$9!#F0:n4D6-$K$h$C$F$O!"(B($B%a%?%-!<(B)+($BLp0u%-!<(B)$B$K$h$C(B
    $B$F$bF1MM$NA`:n$r9T$&$3$H$,$G$-$k>l9g$,$"$j$^$9!#(B

  $B"!%&%$%s%I%&$N?-=L(B
    `+' $B$G%&%$%s%I%&$r=DJ}8~$K?-$P$7!"(B`-' $B$G=L$a$^$9!#(B

($BCf5iJT=*$j(B)"
  nil)

(defun sirup-doc-002 ()
  "$B;H$$$+$?(B --- $B>e5iJT(B ($B%-!<3d$jEv$F$OI8=`@_Dj$G$N$b$N$G$9!#(B)

  $B"!%P%C%U%!$NJ#@=!&:o=|(B
    `C-w' $B$G%P%C%U%!$NJ#@=$,$G$-$^$9!#8!:w7k2L$rJ]B8$7$F$*$$$FJL$N8!:w(B
    $B$r$7$?$$>l9g$J$I$KMxMQ$7$F$/$@$5$$!#A0CV0z?t$r$D$1$k$H%3%T!<@h$N%P%C(B
    $B%U%!L>$r;XDj$G$-$^$9!#(B($B$?$@$7!"I,$:?75,$N%P%C%U%!$,$D$/$i$l$^$9!#(B)
    $B$^$?!"(B`C-k' $B$G%P%C%U%!$,:o=|$5$l$^$9!#$3$N%-!<$G:G8e$N%P%C%U%!$r:o(B
    $B=|$7$?$H$-$K$O!"%5!<%P$H$N@\B3$b@ZCG$9$k$+$I$&$+J9$$$F$-$^$9$N$G!"(B
    `y' $B$+(B `n' $B$GEz$($F$/$@$5$$!#(B

  $B"!%Z!<%8$N%J%m!<%$%s%0(B
    $BI8=`@_Dj$G$O3F%Z!<%8$,FHN)$7$F$$$k$h$&$K8+$($^$9$,!"<B$O%P%C%U%!$K(B
    $B$O@hAD$N%Z!<%8$bJ]B8$5$l$F$$$F!"(BEmacs $B$N%J%m!<%$%s%0$N5!G=$rMQ$$$F(B
    $B8DJL$K8+$;$F$$$^$9!#(B`=' $B%-!<$G$3$N%J%m!<%$%s%0$N(B ON/OFF $B$N@Z$j49$((B
    $B$,9T$($^$9!#$b$7%G%U%)%k%H$G%J%m!<%$%s%0$r(B OFF $B$K$7$?$$>l9g$O!"(B
    ~/.emacs $B$K(B

        (setq sirup-narrow-to-page-flag nil)

    $B$H$$$&9T$r2C$($F$/$@$5$$!#(B
    $B%J%m!<%$%s%0(B OFF $B$N>uBV$G%Z!<%8$N@hF,$d:G8e$K0\F0$9$k$K$O!"(B`[' $B$d(B
   `]' $B$rMQ$$$k$HJXMx$G$9!#(B($B<B$O(B `]' $B$O(B `_' $B$d(B `M-d' $B$HF1$8$G$9!#(B)

($B>e5iJT=*$j(B)"
  nil)

(defun sirup-doc-fa9 ()
  "$B$h$/$"$k<ALd$H2sEz(B

$B:G=i$N%j%j!<%9$J$N$G!V$h$/$"$k!W<ALd$H2sEz$G$O$J$/!"!VA[Dj$5$l$k!W<ALd(B
$B$H2sEz$K$J$C$F$$$^$9!#0-$7$+$i$:!#(B

    Q. Emacs 20.2 $B$d(B XEmacs 20.3 $B$G!"(B`C-\\' $B$G$NF|K\8lF~NO$r$7$h$&$H$9(B
       $B$k$H(B `Command attempted to use minibuffer while in minibuffer'
       $B$H8@$o$l$FE\$i$l$k$s$G$9$,!#(B
    A. Emacs 20.2 $B$N>l9g$O(B

        (set-language-environment \"Japanese\")

       $B$r(B ~/.emacs $B$KF~$l$F$/$@$5$$!#(B
       XEmacs 20.3 $B$N>l9g$O!"Nc$($P(B

        (setq default-input-method 'japanese-egg-wnn)

       $B$H$+$rF~$l$k$H>e$N%(%i!<$O=P$J$/$J$j$^$9$,!"$G$b$^$@$A$g$C$HJQ(B
       $B$_$?$$$G$9!#(B($B$9$_$^$;$s!#$"$^$j;H$o$J$$$N$G$h$/$o$+$i$J$$$N$G$9!#(B)

    Q. $B2?$GBgJ8;z$N%-!<$K$O%3%^%s%I$,3d$jEv$F$i$l$F$J$$$s$G$9$+(B?
    A. $B$"$H$G2?$+LLGr$$5!G=$r;W$$IU$$$?$H$-$N$?$a$K2?$H$J$/$H$C$F$*$$(B
       $B$F$"$j$^$9!#(B

    Q. $B%Z!<%8$N@hF,$KI=<($5$l$F$$$k?t;z$O2?$G$9$+(B?
    A. $B$"$J$?$N:#F|$N%i%C%-!<%J%s%P!<$G$9!#$3$N2s?t$@$1@iMU$NJ}8~$K8~(B
       $B$+$C$F$*5'$j$r$9$k$H!";~4V$NL5BL$K$J$j$^$9!#(B

($B$h$/$"$k<ALd$H2sEz=*$j(B)"
  nil)

(defun sirup-doc-added ()
  "$BJQ99MzNr(B

  ver. 1.0 initial release

($BJQ99MzNr=*$j(B)"
  nil)

(provide 'sirup-doc)
;;; sirup-doc.el ends here

